Bug 54868 - NFS sever file lock is broken in 2.4.9-6
Summary: NFS sever file lock is broken in 2.4.9-6
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Linux
Classification: Retired
Component: kernel
Version: 7.1
Hardware: i386
OS: Linux
high
high
Target Milestone: ---
Assignee: Arjan van de Ven
QA Contact: Brock Organ
URL:
Whiteboard:
Keywords:
: 54891 (view as bug list)
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2001-10-22 05:46 UTC by hjl
Modified: 2014-01-21 22:48 UTC (History)
9 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2001-10-25 08:48:59 UTC


Attachments (Terms of Use)
a testcase (1.30 KB, patch)
2001-10-22 05:46 UTC, hjl
no flags Details | Diff
The Connectathon Testsuite (83.50 KB, application/octet-stream)
2001-10-22 06:19 UTC, hjl
no flags Details
Client lockd kernel traceback (3.27 KB, text/plain)
2001-10-22 19:01 UTC, Bob Matthews
no flags Details
nlm_debug output of client lockd (606 bytes, text/plain)
2001-10-22 19:03 UTC, Bob Matthews
no flags Details
server lockd kernel traceback (1.24 KB, text/plain)
2001-10-22 19:04 UTC, Bob Matthews
no flags Details
server lockd nlm_debug output (256 bytes, text/plain)
2001-10-22 19:05 UTC, Bob Matthews
no flags Details
A patch (1.71 KB, patch)
2001-10-22 21:56 UTC, hjl
no flags Details | Diff


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2001:142 normal SHIPPED_LIVE kernel 2.2 and 2.4: kernel 2.2 and 2.4: 2001-10-26 04:00:00 UTC

Description hjl 2001-10-22 05:46:07 UTC
In a NFS mounted directory against the NFS
sever running kernel 2.4.9-6:

# gcc test.c
# a.out
Opening 'testlock' for writing.
Success!

Trying to get a read lock for 'testlock'


It fails to get a read lock from the NFS
server running 2.4.9-6.

Comment 1 hjl 2001-10-22 05:46:44 UTC
Created attachment 34561 [details]
a testcase

Comment 2 hjl 2001-10-22 05:50:01 UTC
Red Hat should run the Connectathon testsuite
before making any new kernels. I can provide
the patched source.

Comment 3 hjl 2001-10-22 06:18:05 UTC
It looks like both NFS server and client in
kernel 2.4.9-6 failed the Connectathon testsuite.
I am enclosing it here.

Comment 4 hjl 2001-10-22 06:19:26 UTC
Created attachment 34562 [details]
The Connectathon Testsuite

Comment 5 Gerald Teschl 2001-10-22 09:03:19 UTC
We have the same problem here on all our nfs servers. This brakes our
entire site;-(


Comment 6 Seth Vidal 2001-10-22 11:29:12 UTC
This will probably affect 7.2 as well - I think the kernels are relatively the same.



Comment 7 Bob Matthews 2001-10-22 18:58:36 UTC
I have been able to verify this with a client/server setup running 2.4.9-6smp on
two minimal 7.2 systems.

The client appears to be hanging in the first fcntl64 syscall generated by the
fcntl library call.  Strace shows that this syscall never returns.

Attached are relevant trace files including kernel tracebacks for lockd and the
test program on the client, nlm_debug output on the client, kernel traceback of
lockd on the server, and nlm_debug out on the server.

Comment 8 Bob Matthews 2001-10-22 19:01:40 UTC
Created attachment 34583 [details]
Client lockd kernel traceback

Comment 9 hjl 2001-10-22 19:02:44 UTC
NFS file locking is broken. I am working on it now.
It may take me a few days to fix it.

Comment 10 Bob Matthews 2001-10-22 19:03:09 UTC
Created attachment 34584 [details]
nlm_debug output of client lockd

Comment 11 Bob Matthews 2001-10-22 19:04:12 UTC
Created attachment 34585 [details]
server lockd kernel traceback

Comment 12 Bob Matthews 2001-10-22 19:05:31 UTC
Created attachment 34586 [details]
server lockd nlm_debug output

Comment 13 Bob Matthews 2001-10-22 19:23:27 UTC
*** Bug 54891 has been marked as a duplicate of this bug. ***

Comment 14 hjl 2001-10-22 21:56:07 UTC
Created attachment 34621 [details]
A patch

Comment 15 hjl 2001-10-22 21:57:04 UTC
I posted a patch which seems to work for me.

Comment 16 Leonard Evens 2001-10-24 03:25:12 UTC
We have applied the patch to make a custom kernel, and it appears to work
for us also.

Comment 17 Seth Vidal 2001-10-24 12:13:53 UTC
I built some new rpms of the 2.4.9-6 and 2.4.9-7(for 7.2) kernels that include
this patch.

I can put them some place public if its helpful to anyone


Comment 18 Arjan van de Ven 2001-10-24 12:16:15 UTC
I'll put up a kernel with the proposed patch up for testing soon; I'm just
trying to see if it's remotely seen (eg it boots etc)

Comment 19 Arjan van de Ven 2001-10-24 13:56:36 UTC
Please try the kernel at

http://people.redhat.com/arjanv/testkernels 

to see if it indeed works

Comment 20 Seth Vidal 2001-10-24 16:10:22 UTC
This will also need to be fixed on the alpha 2.4.9 kernel on 7.1

will the same patch work?


Comment 21 Anvil 2001-10-25 07:22:48 UTC
Hello gentlemen,
I got 2 little questions :
1/ Has enigma kernel the same problem ? If yes, will the 2.4.9-7.4 work on enigma ?
2/ May we have the kernel-header and kernel-source i386.rpm please ?

Comment 22 Gerald Teschl 2001-10-25 08:48:54 UTC
I had a look at the 7.2 kernel and found out that the svc code is correct,
however, the nfs patch from redhat undoes this. I removed the these lines
from the nfs patch and rebuild the rpms. The kernel now works fine under both
7.1 and 7.2.

Comment 23 Arjan van de Ven 2001-11-03 17:56:13 UTC
This is fixed in yesterdays kernel erratum.
Thanks for reporting this!


Note You need to log in before you can comment on or make changes to this bug.